【双指针】Leetcode 有效三角形的个数

题目解析

611. 有效三角形的个数


算法讲解

回顾知识:任意两数之和大于第三数就可以构成三角形

算法 1:暴力枚举

c 复制代码
int triangleNumber(vector<int>& nums) 
{
	 // 1. 排序
 	sort(nums.begin(), nums.end());
 	int n = nums.size(), ret = 0;
 	// 2. 从⼩到⼤枚举所有的三元组
 	for (int i = 0; i < n; i++) 
 	{
 		for (int j = i + 1; j < n; j++) 
 		{
 			for (int k = j + 1; k < n; k++) 
 			{
 				// 当最⼩的两个边之和⼤于第三边的时候,统计答案
 				if (nums[i] + nums[j] > nums[k])
 				ret++;
 			} 
 		}
	 }
 	return ret;
 }

我们通过枚举每三个没有使用的数字,但是这样加上sort函数的时间,时间复杂度太高

算法 2:双指针

我们先确定一个最大数,然后在这个最大数的左边的区间寻找有效三角形

  • 如果现在的左右指针的值加起来已经 > 每一次确定的最大值:那么现在的left指针已经不需要移动了,因为当前这个数组已经是经过排序的了,所以当前的left满足条件,left右边的数字也满足条件,此时left, right区间的有效三角形的个数就是right - left
  • 如果现在左右指针的值讲起来 <= 每一次确定的最大值:那么就需要将left++,在新的left, right区间中寻找有效三角形个数,left++的道理同上述

代码编写

cpp 复制代码
class Solution {
public:
    int triangleNumber(vector<int>& nums) {
        //先排序
        sort(nums.begin(), nums.end());
        //两数之和 > 第三数
        int ret = 0;
        int n = nums.size();
        for(int i = n - 1; i >= 2; i--)
        {
            int left = 0;
            int right = i - 1;
            //现在nums[i] 就是最大的值,在最大值左边的有序区间里面寻找有效三角形
            while(left < right)
            {
                if(nums[left] + nums[right] > nums[i]) 
                {
                    ret += (right - left);
                    right--;  
                }
                else left++;
            }
        }
        return ret;
    }
};

相关推荐
ZhengEnCi4 小时前
GPT-6 Astra 爆改 Qwen 权重真有那么神吗:权重空间编程 0.016% 参数的真相
算法·架构
罗西的思考4 小时前
【轻量化复刻大模型 / KIMI K3】KDA(Kimi Delta Attention):并行
人工智能·算法·机器学习
夜不会漫长6 小时前
C++:红黑树
数据结构·算法
文丑颜不良啊6 小时前
LeetCode1661~1680题目解析
java·leetcode
AI备案指南-满满7 小时前
算法备案审核不通过,一般是什么原因?
java·人工智能·算法·大模型备案·算法备案·大模型登记
Ramble_Naylor7 小时前
Rust深度解读:Send 与 Sync 的本质与线程安全边界
python·算法·rust
秋天的怀念_David7 小时前
算法一千零一夜 · 第二十三夜 电力民生写成的曲线
java·程序人生·算法
不一样的故事1267 小时前
NB/T 47013.8-2015 附录D 吸枪技术
人工智能·经验分享·算法
通问AI7 小时前
用 200 行 Python 给文档库做「上下文完整度」自检:四个可复算的检查项
算法
揽星河..8 小时前
【C语言】扫雷游戏
c语言·算法·游戏